/*******************************************************************************
*
*
* File:        tau_queue.h
* Description  tau в
* Version      V0.1
* Date         2021-02-25
* Author       lzy
 *******************************************************************************/
#ifndef _TAU_QUEUE_H
#define _TAU_QUEUE_H

#include <stdio.h>
#include <stdlib.h>

typedef struct node_t
{
    void *data;
    struct node_t *next;
} node_t;

typedef node_t node;

typedef struct
{
    node *next;
    node *tail;
    int count;
    int max_size;
} tau_queue_t;

//node
node *tau_new_node(void *data);
//ͷnode
void tau_free_node(node *qn);
//
tau_queue_t *tau_new_queue(int max_size);
//ͷŶ
void tau_free_queue(tau_queue_t *q);
// 0 Ϊʧܣ1Ϊɹ
int tau_queue_push(tau_queue_t *q, void *data);
//
void *tau_queue_pop(tau_queue_t *q);
//ȡsize
int tau_queue_size(tau_queue_t *q);
//ǷΪ
int tau_queue_empty(tau_queue_t *q);
//Ƿ
int tau_queue_full(tau_queue_t *q);



#endif

